# List Customers

> Source: https://truto.one/docs/api-reference/unified-e-commerce-api/customers/list/

`GET /unified/ecommerce/customers`

Resource: **Customers** · API: **Unified E-Commerce API**

## Supported integrations

Bigcommerce, Commerce7, Shopify, Wix, WooCommerce, Zoho Inventory (partial)

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`created_at`** _(string)_
  The date and time when customer was created
- **`updated_at`** _(string)_
  The date and time when customer was updated
- **`name`** _(string)_
  The full name of customer
- **`emails`** _(array<object>)_
  The emails of customer
- **`sort_by`** _(object)_
- **`email`** _(unknown)_
- **`company_name`** _(string)_
  The company name of customer
- **`first_name`** _(string)_
  The first name of customer
- **`last_name`** _(string)_
  The last name of customer
- **`phones`** _(array<object>)_
  The phone numbers of customer

## Response body

- **`result`** _(array<object>)_
  List of Customers
  - **`id`** _(string)_
    The unique identifier for customer
  - **`first_name`** _(string)_
    The first name of customer
  - **`last_name`** _(string)_
    The last name of customer
  - **`name`** _(string)_
    The full name of customer
  - **`company_name`** _(string)_
    The company name of customer
  - **`status`** _(string)_
    The status of customer. If no clear mapping exists, then raw value is returned.
    Allowed: `active`, `inactive`
  - **`currency`** _(string)_
    The currency associated to customer
  - **`emails`** _(array<object>)_
    The emails of customer
    - **`email`** _(string, required)_
      The email of the customer
    - **`type`** _(string)_
      The type of email
    - **`is_primary`** _(boolean)_
      The status of email
  - **`phones`** _(array<object>)_
    The phone numbers of customer
    - **`number`** _(string, required)_
      The number of phone
    - **`extension`** _(string)_
      The extension of the phone number
    - **`type`** _(string)_
      The type of phone
  - **`addresses`** _(array<object>)_
    The addresses of a customer
    - **`type`** _(string)_
      The type of an address of a customer
    - **`id`** _(string)_
      The unique identifier of an address of a customer
    - **`street_1`** _(string)_
      The first line of address of a customer
    - **`street_2`** _(string)_
      The second line of address of a customer
    - **`city`** _(string)_
      The city of the address of a customer
    - **`state`** _(string)_
      The state/province of the address of a customer
    - **`postal_code`** _(string)_
      The postal code of the address of a customer
    - **`country`** _(string)_
      The country of the address of a customer
  - **`orders`** _(array<object>)_
    The orders of customer
    - **`id`** _(string)_
      The id of orders of the customer
    - **`total`** _(string)_
      The total amount of orders of email
    - **`status`** _(string)_
      The status of orders of the customer
  - **`created_at`** _(string)_
    The date and time when customer was created
  - **`updated_at`** _(string)_
    The date and time when customer was updated
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/ecommerce/customers?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/ecommerce/customers?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ecommerce/customers"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'ecommerce',
  'customers',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "ecommerce",
        "customers",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
